Index: XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "axis.hpp"
+#include "node_type.hpp"
 
 extern "C"
@@ -109,8 +109,7 @@
   void cxios_set_axis_value(axis_Ptr axis_hdl, double* value, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(double,1) array_tmp(new CArray<double,1>(boost::extents[extent1]));
-    std::copy(value, &(value[array_tmp->num_elements()]), array_tmp->data());
-    axis_hdl->value.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(value,shape(extent1),neverDeleteData) ;
+    axis_hdl->value.reference(tmp.copy());
     axis_hdl->sendAttributToServer(axis_hdl->value);
   }
@@ -118,7 +117,49 @@
   void cxios_get_axis_value(axis_Ptr axis_hdl, double* value, int extent1)
   {
-    if (!array_copy(axis_hdl->value.getValue(), value, extent1))
-     ERROR("void cxios_set_axis_value(axis_Ptr axis_hdl, double* value, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<double,1> tmp(value,shape(extent1),neverDeleteData) ;
+    tmp=axis_hdl->value ;
      CTimer::get("XIOS").suspend();
+  }
+  
+  
+  void cxios_set_axis_zoom_begin(axis_Ptr axis_hdl, int zoom_begin)
+  {
+     CTimer::get("XIOS").resume();
+    axis_hdl->zoom_begin.setValue(zoom_begin);
+    axis_hdl->sendAttributToServer(axis_hdl->zoom_begin);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axis_zoom_begin(axis_Ptr axis_hdl, int* zoom_begin)
+  {
+    *zoom_begin = axis_hdl->zoom_begin.getValue();
+  }
+  
+  
+  void cxios_set_axis_zoom_end(axis_Ptr axis_hdl, int zoom_end)
+  {
+     CTimer::get("XIOS").resume();
+    axis_hdl->zoom_end.setValue(zoom_end);
+    axis_hdl->sendAttributToServer(axis_hdl->zoom_end);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axis_zoom_end(axis_Ptr axis_hdl, int* zoom_end)
+  {
+    *zoom_end = axis_hdl->zoom_end.getValue();
+  }
+  
+  
+  void cxios_set_axis_zoom_size(axis_Ptr axis_hdl, int zoom_size)
+  {
+     CTimer::get("XIOS").resume();
+    axis_hdl->zoom_size.setValue(zoom_size);
+    axis_hdl->sendAttributToServer(axis_hdl->zoom_size);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axis_zoom_size(axis_Ptr axis_hdl, int* zoom_size)
+  {
+    *zoom_size = axis_hdl->zoom_size.getValue();
   }
   
Index: XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "axis.hpp"
+#include "node_type.hpp"
 
 extern "C"
@@ -128,8 +128,7 @@
   void cxios_set_axisgroup_value(axisgroup_Ptr axisgroup_hdl, double* value, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(double,1) array_tmp(new CArray<double,1>(boost::extents[extent1]));
-    std::copy(value, &(value[array_tmp->num_elements()]), array_tmp->data());
-    axisgroup_hdl->value.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(value,shape(extent1),neverDeleteData) ;
+    axisgroup_hdl->value.reference(tmp.copy());
     axisgroup_hdl->sendAttributToServer(axisgroup_hdl->value);
   }
@@ -137,7 +136,49 @@
   void cxios_get_axisgroup_value(axisgroup_Ptr axisgroup_hdl, double* value, int extent1)
   {
-    if (!array_copy(axisgroup_hdl->value.getValue(), value, extent1))
-     ERROR("void cxios_set_axisgroup_value(axisgroup_Ptr axisgroup_hdl, double* value, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<double,1> tmp(value,shape(extent1),neverDeleteData) ;
+    tmp=axisgroup_hdl->value ;
      CTimer::get("XIOS").suspend();
+  }
+  
+  
+  void cxios_set_axisgroup_zoom_begin(axisgroup_Ptr axisgroup_hdl, int zoom_begin)
+  {
+     CTimer::get("XIOS").resume();
+    axisgroup_hdl->zoom_begin.setValue(zoom_begin);
+    axisgroup_hdl->sendAttributToServer(axisgroup_hdl->zoom_begin);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axisgroup_zoom_begin(axisgroup_Ptr axisgroup_hdl, int* zoom_begin)
+  {
+    *zoom_begin = axisgroup_hdl->zoom_begin.getValue();
+  }
+  
+  
+  void cxios_set_axisgroup_zoom_end(axisgroup_Ptr axisgroup_hdl, int zoom_end)
+  {
+     CTimer::get("XIOS").resume();
+    axisgroup_hdl->zoom_end.setValue(zoom_end);
+    axisgroup_hdl->sendAttributToServer(axisgroup_hdl->zoom_end);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axisgroup_zoom_end(axisgroup_Ptr axisgroup_hdl, int* zoom_end)
+  {
+    *zoom_end = axisgroup_hdl->zoom_end.getValue();
+  }
+  
+  
+  void cxios_set_axisgroup_zoom_size(axisgroup_Ptr axisgroup_hdl, int zoom_size)
+  {
+     CTimer::get("XIOS").resume();
+    axisgroup_hdl->zoom_size.setValue(zoom_size);
+    axisgroup_hdl->sendAttributToServer(axisgroup_hdl->zoom_size);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axisgroup_zoom_size(axisgroup_Ptr axisgroup_hdl, int* zoom_size)
+  {
+    *zoom_size = axisgroup_hdl->zoom_size.getValue();
   }
   
Index: XIOS/trunk/src/interface/c_attr/iccontext_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/iccontext_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/iccontext_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "context.hpp"
+#include "node_type.hpp"
 
 extern "C"
Index: XIOS/trunk/src/interface/c_attr/icdomain_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icdomain_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icdomain_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "domain.hpp"
+#include "node_type.hpp"
 
 extern "C"
@@ -33,8 +33,7 @@
   void cxios_set_domain_data_i_index(domain_Ptr domain_hdl, int* data_i_index, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(int,1) array_tmp(new CArray<int,1>(boost::extents[extent1]));
-    std::copy(data_i_index, &(data_i_index[array_tmp->num_elements()]), array_tmp->data());
-    domain_hdl->data_i_index.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(data_i_index,shape(extent1),neverDeleteData) ;
+    domain_hdl->data_i_index.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->data_i_index);
   }
@@ -42,6 +41,6 @@
   void cxios_get_domain_data_i_index(domain_Ptr domain_hdl, int* data_i_index, int extent1)
   {
-    if (!array_copy(domain_hdl->data_i_index.getValue(), data_i_index, extent1))
-     ERROR("void cxios_set_domain_data_i_index(domain_Ptr domain_hdl, int* data_i_index, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<int,1> tmp(data_i_index,shape(extent1),neverDeleteData) ;
+    tmp=domain_hdl->data_i_index ;
      CTimer::get("XIOS").suspend();
   }
@@ -64,8 +63,7 @@
   void cxios_set_domain_data_j_index(domain_Ptr domain_hdl, int* data_j_index, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(int,1) array_tmp(new CArray<int,1>(boost::extents[extent1]));
-    std::copy(data_j_index, &(data_j_index[array_tmp->num_elements()]), array_tmp->data());
-    domain_hdl->data_j_index.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(data_j_index,shape(extent1),neverDeleteData) ;
+    domain_hdl->data_j_index.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->data_j_index);
   }
@@ -73,6 +71,6 @@
   void cxios_get_domain_data_j_index(domain_Ptr domain_hdl, int* data_j_index, int extent1)
   {
-    if (!array_copy(domain_hdl->data_j_index.getValue(), data_j_index, extent1))
-     ERROR("void cxios_set_domain_data_j_index(domain_Ptr domain_hdl, int* data_j_index, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<int,1> tmp(data_j_index,shape(extent1),neverDeleteData) ;
+    tmp=domain_hdl->data_j_index ;
      CTimer::get("XIOS").suspend();
   }
@@ -212,8 +210,7 @@
   void cxios_set_domain_latvalue(domain_Ptr domain_hdl, double* latvalue, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(double,1) array_tmp(new CArray<double,1>(boost::extents[extent1]));
-    std::copy(latvalue, &(latvalue[array_tmp->num_elements()]), array_tmp->data());
-    domain_hdl->latvalue.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(latvalue,shape(extent1),neverDeleteData) ;
+    domain_hdl->latvalue.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->latvalue);
   }
@@ -221,6 +218,6 @@
   void cxios_get_domain_latvalue(domain_Ptr domain_hdl, double* latvalue, int extent1)
   {
-    if (!array_copy(domain_hdl->latvalue.getValue(), latvalue, extent1))
-     ERROR("void cxios_set_domain_latvalue(domain_Ptr domain_hdl, double* latvalue, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<double,1> tmp(latvalue,shape(extent1),neverDeleteData) ;
+    tmp=domain_hdl->latvalue ;
      CTimer::get("XIOS").suspend();
   }
@@ -248,8 +245,7 @@
   void cxios_set_domain_lonvalue(domain_Ptr domain_hdl, double* lonvalue, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(double,1) array_tmp(new CArray<double,1>(boost::extents[extent1]));
-    std::copy(lonvalue, &(lonvalue[array_tmp->num_elements()]), array_tmp->data());
-    domain_hdl->lonvalue.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(lonvalue,shape(extent1),neverDeleteData) ;
+    domain_hdl->lonvalue.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->lonvalue);
   }
@@ -257,6 +253,6 @@
   void cxios_get_domain_lonvalue(domain_Ptr domain_hdl, double* lonvalue, int extent1)
   {
-    if (!array_copy(domain_hdl->lonvalue.getValue(), lonvalue, extent1))
-     ERROR("void cxios_set_domain_lonvalue(domain_Ptr domain_hdl, double* lonvalue, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<double,1> tmp(lonvalue,shape(extent1),neverDeleteData) ;
+    tmp=domain_hdl->lonvalue ;
      CTimer::get("XIOS").suspend();
   }
@@ -265,8 +261,7 @@
   void cxios_set_domain_mask(domain_Ptr domain_hdl, bool* mask, int extent1, int extent2)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(bool,2) array_tmp(new CArray<bool,2>(boost::extents[extent1][extent2]));
-    std::copy(mask, &(mask[array_tmp->num_elements()]), array_tmp->data());
-    domain_hdl->mask.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<bool,2> tmp(mask,shape(extent1,extent2),neverDeleteData) ;
+    domain_hdl->mask.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->mask);
   }
@@ -274,6 +269,6 @@
   void cxios_get_domain_mask(domain_Ptr domain_hdl, bool* mask, int extent1, int extent2)
   {
-    if (!array_copy(domain_hdl->mask.getValue(), mask, extent1, extent2))
-     ERROR("void cxios_set_domain_mask(domain_Ptr domain_hdl, bool* mask, int extent1, int extent2)",<<"Output array size is not conform to array size attribute") ;
+    CArray<bool,2> tmp(mask,shape(extent1,extent2),neverDeleteData) ;
+    tmp=domain_hdl->mask ;
      CTimer::get("XIOS").suspend();
   }
Index: XIOS/trunk/src/interface/c_attr/icdomaingroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icdomaingroup_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icdomaingroup_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "domain.hpp"
+#include "node_type.hpp"
 
 extern "C"
@@ -33,8 +33,7 @@
   void cxios_set_domaingroup_data_i_index(domaingroup_Ptr domaingroup_hdl, int* data_i_index, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(int,1) array_tmp(new CArray<int,1>(boost::extents[extent1]));
-    std::copy(data_i_index, &(data_i_index[array_tmp->num_elements()]), array_tmp->data());
-    domaingroup_hdl->data_i_index.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(data_i_index,shape(extent1),neverDeleteData) ;
+    domaingroup_hdl->data_i_index.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_i_index);
   }
@@ -42,6 +41,6 @@
   void cxios_get_domaingroup_data_i_index(domaingroup_Ptr domaingroup_hdl, int* data_i_index, int extent1)
   {
-    if (!array_copy(domaingroup_hdl->data_i_index.getValue(), data_i_index, extent1))
-     ERROR("void cxios_set_domaingroup_data_i_index(domaingroup_Ptr domaingroup_hdl, int* data_i_index, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<int,1> tmp(data_i_index,shape(extent1),neverDeleteData) ;
+    tmp=domaingroup_hdl->data_i_index ;
      CTimer::get("XIOS").suspend();
   }
@@ -64,8 +63,7 @@
   void cxios_set_domaingroup_data_j_index(domaingroup_Ptr domaingroup_hdl, int* data_j_index, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(int,1) array_tmp(new CArray<int,1>(boost::extents[extent1]));
-    std::copy(data_j_index, &(data_j_index[array_tmp->num_elements()]), array_tmp->data());
-    domaingroup_hdl->data_j_index.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(data_j_index,shape(extent1),neverDeleteData) ;
+    domaingroup_hdl->data_j_index.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_j_index);
   }
@@ -73,6 +71,6 @@
   void cxios_get_domaingroup_data_j_index(domaingroup_Ptr domaingroup_hdl, int* data_j_index, int extent1)
   {
-    if (!array_copy(domaingroup_hdl->data_j_index.getValue(), data_j_index, extent1))
-     ERROR("void cxios_set_domaingroup_data_j_index(domaingroup_Ptr domaingroup_hdl, int* data_j_index, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<int,1> tmp(data_j_index,shape(extent1),neverDeleteData) ;
+    tmp=domaingroup_hdl->data_j_index ;
      CTimer::get("XIOS").suspend();
   }
@@ -231,8 +229,7 @@
   void cxios_set_domaingroup_latvalue(domaingroup_Ptr domaingroup_hdl, double* latvalue, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(double,1) array_tmp(new CArray<double,1>(boost::extents[extent1]));
-    std::copy(latvalue, &(latvalue[array_tmp->num_elements()]), array_tmp->data());
-    domaingroup_hdl->latvalue.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(latvalue,shape(extent1),neverDeleteData) ;
+    domaingroup_hdl->latvalue.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->latvalue);
   }
@@ -240,6 +237,6 @@
   void cxios_get_domaingroup_latvalue(domaingroup_Ptr domaingroup_hdl, double* latvalue, int extent1)
   {
-    if (!array_copy(domaingroup_hdl->latvalue.getValue(), latvalue, extent1))
-     ERROR("void cxios_set_domaingroup_latvalue(domaingroup_Ptr domaingroup_hdl, double* latvalue, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<double,1> tmp(latvalue,shape(extent1),neverDeleteData) ;
+    tmp=domaingroup_hdl->latvalue ;
      CTimer::get("XIOS").suspend();
   }
@@ -267,8 +264,7 @@
   void cxios_set_domaingroup_lonvalue(domaingroup_Ptr domaingroup_hdl, double* lonvalue, int extent1)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(double,1) array_tmp(new CArray<double,1>(boost::extents[extent1]));
-    std::copy(lonvalue, &(lonvalue[array_tmp->num_elements()]), array_tmp->data());
-    domaingroup_hdl->lonvalue.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<double,1> tmp(lonvalue,shape(extent1),neverDeleteData) ;
+    domaingroup_hdl->lonvalue.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->lonvalue);
   }
@@ -276,6 +272,6 @@
   void cxios_get_domaingroup_lonvalue(domaingroup_Ptr domaingroup_hdl, double* lonvalue, int extent1)
   {
-    if (!array_copy(domaingroup_hdl->lonvalue.getValue(), lonvalue, extent1))
-     ERROR("void cxios_set_domaingroup_lonvalue(domaingroup_Ptr domaingroup_hdl, double* lonvalue, int extent1)",<<"Output array size is not conform to array size attribute") ;
+    CArray<double,1> tmp(lonvalue,shape(extent1),neverDeleteData) ;
+    tmp=domaingroup_hdl->lonvalue ;
      CTimer::get("XIOS").suspend();
   }
@@ -284,8 +280,7 @@
   void cxios_set_domaingroup_mask(domaingroup_Ptr domaingroup_hdl, bool* mask, int extent1, int extent2)
   {
-     CTimer::get("XIOS").resume();
-    ARRAY(bool,2) array_tmp(new CArray<bool,2>(boost::extents[extent1][extent2]));
-    std::copy(mask, &(mask[array_tmp->num_elements()]), array_tmp->data());
-    domaingroup_hdl->mask.setValue(array_tmp);
+    CTimer::get("XIOS").resume();
+    CArray<bool,2> tmp(mask,shape(extent1,extent2),neverDeleteData) ;
+    domaingroup_hdl->mask.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->mask);
   }
@@ -293,6 +288,6 @@
   void cxios_get_domaingroup_mask(domaingroup_Ptr domaingroup_hdl, bool* mask, int extent1, int extent2)
   {
-    if (!array_copy(domaingroup_hdl->mask.getValue(), mask, extent1, extent2))
-     ERROR("void cxios_set_domaingroup_mask(domaingroup_Ptr domaingroup_hdl, bool* mask, int extent1, int extent2)",<<"Output array size is not conform to array size attribute") ;
+    CArray<bool,2> tmp(mask,shape(extent1,extent2),neverDeleteData) ;
+    tmp=domaingroup_hdl->mask ;
      CTimer::get("XIOS").suspend();
   }
Index: XIOS/trunk/src/interface/c_attr/icfield_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfield_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icfield_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "field.hpp"
+#include "node_type.hpp"
 
 extern "C"
Index: XIOS/trunk/src/interface/c_attr/icfieldgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfieldgroup_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icfieldgroup_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "field.hpp"
+#include "node_type.hpp"
 
 extern "C"
Index: XIOS/trunk/src/interface/c_attr/icfile_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "file.hpp"
+#include "node_type.hpp"
 
 extern "C"
@@ -183,5 +183,5 @@
     if(!cstr2string(type, type_size, type_str)) return;
      CTimer::get("XIOS").resume();
-    file_hdl->type.setValue(type_str);
+    file_hdl->type.fromString(type_str);
     file_hdl->sendAttributToServer(file_hdl->type);
      CTimer::get("XIOS").suspend();
@@ -191,5 +191,5 @@
   {
      CTimer::get("XIOS").resume();
-    if(!string_copy(file_hdl->type.getValue(),type , type_size))
+    if(!string_copy(file_hdl->type.getStringValue(),type , type_size))
       ERROR("void cxios_get_file_type(file_Ptr file_hdl, char * type, int type_size)", <<"Input string is to short");
      CTimer::get("XIOS").suspend();
Index: XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "file.hpp"
+#include "node_type.hpp"
 
 extern "C"
@@ -202,5 +202,5 @@
     if(!cstr2string(type, type_size, type_str)) return;
      CTimer::get("XIOS").resume();
-    filegroup_hdl->type.setValue(type_str);
+    filegroup_hdl->type.fromString(type_str);
     filegroup_hdl->sendAttributToServer(filegroup_hdl->type);
      CTimer::get("XIOS").suspend();
@@ -210,5 +210,5 @@
   {
      CTimer::get("XIOS").resume();
-    if(!string_copy(filegroup_hdl->type.getValue(),type , type_size))
+    if(!string_copy(filegroup_hdl->type.getStringValue(),type , type_size))
       ERROR("void cxios_get_filegroup_type(filegroup_Ptr filegroup_hdl, char * type, int type_size)", <<"Input string is to short");
      CTimer::get("XIOS").suspend();
Index: XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "grid.hpp"
+#include "node_type.hpp"
 
 extern "C"
Index: XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp	(revision 368)
+++ XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp	(revision 369)
@@ -11,5 +11,5 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "grid.hpp"
+#include "node_type.hpp"
 
 extern "C"
Index: XIOS/trunk/src/interface/fortran_attr/axis_interface_attr.f90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/axis_interface_attr.f90	(revision 368)
+++ XIOS/trunk/src/interface/fortran_attr/axis_interface_attr.f90	(revision 369)
@@ -97,4 +97,43 @@
     
     
+    SUBROUTINE cxios_set_axis_zoom_begin(axis_hdl, zoom_begin) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axis_hdl
+      INTEGER (KIND=C_INT)      , VALUE :: zoom_begin
+    END SUBROUTINE cxios_set_axis_zoom_begin
+    
+    SUBROUTINE cxios_get_axis_zoom_begin(axis_hdl, zoom_begin) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axis_hdl
+      INTEGER (KIND=C_INT)             :: zoom_begin
+    END SUBROUTINE cxios_get_axis_zoom_begin
+    
+    
+    SUBROUTINE cxios_set_axis_zoom_end(axis_hdl, zoom_end) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axis_hdl
+      INTEGER (KIND=C_INT)      , VALUE :: zoom_end
+    END SUBROUTINE cxios_set_axis_zoom_end
+    
+    SUBROUTINE cxios_get_axis_zoom_end(axis_hdl, zoom_end) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axis_hdl
+      INTEGER (KIND=C_INT)             :: zoom_end
+    END SUBROUTINE cxios_get_axis_zoom_end
+    
+    
+    SUBROUTINE cxios_set_axis_zoom_size(axis_hdl, zoom_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axis_hdl
+      INTEGER (KIND=C_INT)      , VALUE :: zoom_size
+    END SUBROUTINE cxios_set_axis_zoom_size
+    
+    SUBROUTINE cxios_get_axis_zoom_size(axis_hdl, zoom_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axis_hdl
+      INTEGER (KIND=C_INT)             :: zoom_size
+    END SUBROUTINE cxios_get_axis_zoom_size
+    
+    
     END INTERFACE
   
Index: XIOS/trunk/src/interface/fortran_attr/axisgroup_interface_attr.f90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/axisgroup_interface_attr.f90	(revision 368)
+++ XIOS/trunk/src/interface/fortran_attr/axisgroup_interface_attr.f90	(revision 369)
@@ -112,4 +112,43 @@
     
     
+    SUBROUTINE cxios_set_axisgroup_zoom_begin(axisgroup_hdl, zoom_begin) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axisgroup_hdl
+      INTEGER (KIND=C_INT)      , VALUE :: zoom_begin
+    END SUBROUTINE cxios_set_axisgroup_zoom_begin
+    
+    SUBROUTINE cxios_get_axisgroup_zoom_begin(axisgroup_hdl, zoom_begin) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axisgroup_hdl
+      INTEGER (KIND=C_INT)             :: zoom_begin
+    END SUBROUTINE cxios_get_axisgroup_zoom_begin
+    
+    
+    SUBROUTINE cxios_set_axisgroup_zoom_end(axisgroup_hdl, zoom_end) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axisgroup_hdl
+      INTEGER (KIND=C_INT)      , VALUE :: zoom_end
+    END SUBROUTINE cxios_set_axisgroup_zoom_end
+    
+    SUBROUTINE cxios_get_axisgroup_zoom_end(axisgroup_hdl, zoom_end) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axisgroup_hdl
+      INTEGER (KIND=C_INT)             :: zoom_end
+    END SUBROUTINE cxios_get_axisgroup_zoom_end
+    
+    
+    SUBROUTINE cxios_set_axisgroup_zoom_size(axisgroup_hdl, zoom_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axisgroup_hdl
+      INTEGER (KIND=C_INT)      , VALUE :: zoom_size
+    END SUBROUTINE cxios_set_axisgroup_zoom_size
+    
+    SUBROUTINE cxios_get_axisgroup_zoom_size(axisgroup_hdl, zoom_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: axisgroup_hdl
+      INTEGER (KIND=C_INT)             :: zoom_size
+    END SUBROUTINE cxios_get_axisgroup_zoom_size
+    
+    
     END INTERFACE
   
Index: XIOS/trunk/src/interface/fortran_attr/iaxis_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/iaxis_attr.F90	(revision 368)
+++ XIOS/trunk/src/interface/fortran_attr/iaxis_attr.F90	(revision 369)
@@ -12,5 +12,6 @@
   
   SUBROUTINE xios(set_axis_attr)  &
-    ( axis_id, long_name, name, size, standard_name, unit, value )
+    ( axis_id, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+     )
     
     IMPLICIT NONE
@@ -23,13 +24,18 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: unit
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: value(:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_begin
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_end
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_size
       
       CALL xios(get_axis_handle)(axis_id,axis_hdl)
       CALL xios(set_axis_attr_hdl_)   &
-      ( axis_hdl, long_name, name, size, standard_name, unit, value )
+      ( axis_hdl, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+       )
     
   END SUBROUTINE xios(set_axis_attr)
   
   SUBROUTINE xios(set_axis_attr_hdl)  &
-    ( axis_hdl, long_name, name, size, standard_name, unit, value )
+    ( axis_hdl, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+     )
     
     IMPLICIT NONE
@@ -41,12 +47,17 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: unit
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: value(:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_begin
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_end
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_size
       
       CALL xios(set_axis_attr_hdl_)  &
-      ( axis_hdl, long_name, name, size, standard_name, unit, value )
+      ( axis_hdl, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+       )
     
   END SUBROUTINE xios(set_axis_attr_hdl)
   
   SUBROUTINE xios(set_axis_attr_hdl_)   &
-    ( axis_hdl, long_name_, name_, size_, standard_name_, unit_, value_ )
+    ( axis_hdl, long_name_, name_, size_, standard_name_, unit_, value_, zoom_begin_, zoom_end_  &
+    , zoom_size_ )
     
     IMPLICIT NONE
@@ -58,4 +69,7 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: unit_
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: value_(:)
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_begin_
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_end_
+      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_size_
       
       IF (PRESENT(long_name_)) THEN
@@ -83,4 +97,16 @@
       ENDIF
       
+      IF (PRESENT(zoom_begin_)) THEN
+        CALL cxios_set_axis_zoom_begin(axis_hdl%daddr, zoom_begin_)
+      ENDIF
+      
+      IF (PRESENT(zoom_end_)) THEN
+        CALL cxios_set_axis_zoom_end(axis_hdl%daddr, zoom_end_)
+      ENDIF
+      
+      IF (PRESENT(zoom_size_)) THEN
+        CALL cxios_set_axis_zoom_size(axis_hdl%daddr, zoom_size_)
+      ENDIF
+      
       
     
@@ -88,5 +114,6 @@
   
   SUBROUTINE xios(get_axis_attr)  &
-    ( axis_id, long_name, name, size, standard_name, unit, value )
+    ( axis_id, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+     )
     
     IMPLICIT NONE
@@ -99,13 +126,18 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: unit
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: value(:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_begin
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_end
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_size
       
       CALL xios(get_axis_handle)(axis_id,axis_hdl)
       CALL xios(get_axis_attr_hdl_)   &
-      ( axis_hdl, long_name, name, size, standard_name, unit, value )
+      ( axis_hdl, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+       )
     
   END SUBROUTINE xios(get_axis_attr)
   
   SUBROUTINE xios(get_axis_attr_hdl)  &
-    ( axis_hdl, long_name, name, size, standard_name, unit, value )
+    ( axis_hdl, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+     )
     
     IMPLICIT NONE
@@ -117,12 +149,17 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: unit
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: value(:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_begin
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_end
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_size
       
       CALL xios(get_axis_attr_hdl_)  &
-      ( axis_hdl, long_name, name, size, standard_name, unit, value )
+      ( axis_hdl, long_name, name, size, standard_name, unit, value, zoom_begin, zoom_end, zoom_size  &
+       )
     
   END SUBROUTINE xios(get_axis_attr_hdl)
   
   SUBROUTINE xios(get_axis_attr_hdl_)   &
-    ( axis_hdl, long_name_, name_, size_, standard_name_, unit_, value_ )
+    ( axis_hdl, long_name_, name_, size_, standard_name_, unit_, value_, zoom_begin_, zoom_end_  &
+    , zoom_size_ )
     
     IMPLICIT NONE
@@ -134,4 +171,7 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: unit_
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: value_(:)
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_begin_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_end_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_size_
       
       IF (PRESENT(long_name_)) THEN
@@ -159,4 +199,16 @@
       ENDIF
       
+      IF (PRESENT(zoom_begin_)) THEN
+        CALL cxios_get_axis_zoom_begin(axis_hdl%daddr, zoom_begin_)
+      ENDIF
+      
+      IF (PRESENT(zoom_end_)) THEN
+        CALL cxios_get_axis_zoom_end(axis_hdl%daddr, zoom_end_)
+      ENDIF
+      
+      IF (PRESENT(zoom_size_)) THEN
+        CALL cxios_get_axis_zoom_size(axis_hdl%daddr, zoom_size_)
+      ENDIF
+      
       
     
